--- Variables: ---
currentVersion = 1.1;
previousSpell = nil;

sounds = {};
sounds.ryu = {};
sounds.ken = {};
sounds.sakura = {};
sounds.dan = {};

-- Ryu sounds:
sounds.ryu.hadouken = "Interface\\AddOns\\Hadouken\\media\\sounds\\RyuHadouken.mp3";
sounds.ryu.shoryuken = "Interface\\AddOns\\Hadouken\\media\\sounds\\RyuShoryuken.mp3";

-- Ken sounds:
sounds.ken.hadouken = "Interface\\AddOns\\Hadouken\\media\\sounds\\KenHadouken.mp3";
sounds.ken.shoryuken = "Interface\\AddOns\\Hadouken\\media\\sounds\\KenShoryuken.mp3";

-- Sakura sounds:
sounds.sakura.hadouken = "Interface\\AddOns\\Hadouken\\media\\sounds\\SakuraHadouken.mp3";
sounds.sakura.shoryuken = "Interface\\AddOns\\Hadouken\\media\\sounds\\SakuraShoryuken.mp3";	
	
-- Dan sounds:
sounds.dan.hadouken = "Interface\\AddOns\\Hadouken\\media\\sounds\\DanHadouken.mp3";
sounds.dan.shoryuken = "Interface\\AddOns\\Hadouken\\media\\sounds\\DanShoryuken.mp3";	
	
savedVariables = {};
savedVariables.spells = {};

savedVariables.spells.hadouken = {};
savedVariables.spells.shoryuken = {};

savedVariables.sound = "";
savedVariables.personal = true;
savedVariables.savedVersion = 0;
names = "";

--- Slash commands: ---
SLASH_HADOUKEN1 = "/hadouken";
SLASH_HADOUKEN2 = "/ha";

SLASH_SHORYUKEN1 = "/shoryuken";
SLASH_SHORYUKEN2 = "/sh";

eventTracker = CreateFrame("Frame", nil, UIParent);
eventTracker:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
eventTracker:RegisterEvent("ADDON_LOADED");
eventTracker:SetScript("OnEvent", eventHandler);

function eventHandler(self, event, ...)

	if event == "ADDON_LOADED" then
		if ... == "Hadouken" then 
			return;
		elseif savedVariables.savedVersion == nil or savedVariables.savedVersion ~= currentVersion then
			savedVariables = {};
			savedVariables.spells = {};

			savedVariables.spells.hadouken = {};
			savedVariables.spells.shoryuken = {};

			savedVariables.sound = "ryu";
			savedVariables.personal = true;
			savedVariables.savedVersion = currentVersion;
			StaticPopup_Show ("HADOUKEN_POPUP", "\nThank you for installing HADOUKEN!\n\nFor compatibility reasons, any previously saved HADOUKEN related settings have been reset.\n\nType: |cFFFFFF00/hadouken help|r or |cFFFFFF00/shoryuken help|r for instructions on how to use the addon.");
		end;
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		spellCaster, spellName, _, spellCount = ...;

		if previousSpell ~= spellCount then
	
			spellName = GetSpellLink(spellName);
	
 			if savedVariables.personal and spellCaster == "player" or savedVariables.personal == false then
			
				for i, v in ipairs(savedVariables.spells.hadouken) do
					if spellName == savedVariables.spells.hadouken[i] then
						PlaySoundFile(sounds[savedVariables.sound].hadouken);
					end;
				end;
			
				for i, v in ipairs(savedVariables.spells.shoryuken) do
					if spellName == savedVariables.spells.shoryuken[i] then
						PlaySoundFile(sounds[savedVariables.sound].shoryuken);
					end;
				end;
			
			end;
		end;
	
		previousSpell = spellCount;
	end;
	
end;

function SlashCmdList.HADOUKEN(spell) handleCommand(spell, "hadouken"); end;
function SlashCmdList.SHORYUKEN(spell) handleCommand(spell, "shoryuken"); end;

function handleCommand(spell, attack)
	
	spell = string.lower(spell);
	
	if spell == "" then
		local dialog = StaticPopup_Show("HADOUKEN_ADD", "\nType the name of the spell you wish to add the " .. string.upper(attack) .. " sound effect to. Or type the name of a spell you added earlier to remove it.\n\nIf you want to do something else, you can alway type |cFFFFFF00/hadouken help|r in the normal chat frame for a list of commands.\n\n\nSpell name:"); 
		if (dialog) then
			dialog.data = attack;
			dialog.button1:Disable();
		end;
		return;
	elseif spell == "help" then 
		StaticPopup_Show("HADOUKEN_POPUP", "|cFFFFFF00HADOUKEN v" .. savedVariables.savedVersion .. "\n\n|rHADOUKEN sound effect:\n|cFFFFFF00/hadouken <comamnd/spell>|r\n\nSHORYUKEN sound effect:\n|cFFFFFF00/shoryuken <command/spell>|r\n\nSee the examples below:\n\n|cFFFFFF00/" .. attack .. " <spell name> |rAdds/removes the " .. string.upper(attack) .. " sound to a spell.\n\n|cFFFFFF00/" .. attack .. " list |rLists the spells you have added the " .. string.upper(attack) .. " sound to.\n\n|cFFFFFF00/" .. attack .. " Ryu |r/|cFFFFFF00 Ken |r/|cFFFFFF00 Sakura |r/|cFFFFFF00 Dan |rSets both HADOUKEN and SHORYUKEN sounds to match the chosen character.\n\n|cFFFFFF00/" .. attack .. " global |rEnables the " .. string.upper(attack) .. " sound on spells cast by other players.\n\n|cFFFFFF00/" .. attack .. " personal |rDisables the " .. string.upper(attack) .. " sound on spells cast by other players.\n\n|cFFFFFF00/" .. attack .. " clear |rClears the list of spells you have added the " .. string.upper(attack) .. " sound to.");
		return;
	elseif spell == "list" then 
		listSpells(attack);
		return;
	elseif spell == "clear" then 
		savedVariables.spells[attack] = {};
		printMessege("Your list of " .. string.upper(attack) .. "'ed spells has been cleared.");
		return;
	elseif spell == "global" then 
		savedVariables.personal = false;
		printMessege("The spell sounds will now trigger on spells cast by other players.");
		return;
	elseif spell == "personal" then 
		savedVariables.personal = true;
		printMessege("The spell sounds will now only trigger on spells cast by you.");
		return;
	elseif spell == "sakura" then 
		savedVariables.sound = "sakura";
		printMessege("Your spell voice has been set to \"Sakura\".");
		return;
	elseif spell == "ken" then 
		savedVariables.sound = "ken";
		printMessege("Your spell voice has been set to \"Ken\".");
		return;
	elseif spell == "ryu" then 
		savedVariables.sound = "ryu";
		printMessege("Your spell voice has been set to \"Ryu\".");
		return;
	elseif spell == "dan" then 
		savedVariables.sound = "dan";
		printMessege("Your spell voice has been set to \"Dan\".");
		return;
	else
		addRemoveSpell(spell, attack);
	end;

end;

function listSpells(attack)
	printMessege("List of " .. string.upper(attack) .. "'ed spells:");
	
	if attack == "hadouken" then for i, spell in ipairs(savedVariables.spells.hadouken) do printMessege(spell) end; end;
	if attack == "shoryuken" then for i, spell in ipairs(savedVariables.spells.shoryuken) do printMessege(spell) end; end;
	
end;

function addRemoveSpell(spell, attack)
	
	spell = validateSpell(spell);
	
	if spell == nil then
		printMessege("Invalid command or spell. Type |cFFFFFF00/" .. attack .. " help|r to get a list of valid commands.");
		return ;
	end;
	
	addSpell = true;
	
	for i, savedSpell in ipairs(savedVariables.spells[attack]) do
		if savedSpell == spell then
			table.remove(savedVariables.spells[attack], i);
			printMessege(savedSpell .. " has been removed from " .. string.upper(attack) .. ".");
			
			addSpell = false;
			
			break;
		end;
	end;
			
	if addSpell then
		table.insert(savedVariables.spells[attack], spell);
		printMessege(spell .. " has been " .. string.upper(attack) .. "'ed.");
	end;
	
end;

function validateSpell(spell)
	if GetSpellLink(spell) then
		return GetSpellLink(spell);
	else
		return nil;
	end;
end;

function printMessege(text)
	print("|cFF00FF00HADOUKEN:|r " .. text);
end;

StaticPopupDialogs["HADOUKEN_RESET"] = {
  text = "\nThank you for installing HADOUKEN!\n\nFor compatibility reasons, any previously saved HADOUKEN related settings have been reset.\n\nType: |cFFFFFF00/hadouken help|r or |cFFFFFF00/shoryuken help|r for instructions on how to use the addon.",
  button1 = "Close",
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
}

StaticPopupDialogs["HADOUKEN_ADD"] = {
	text = "%s",
	button1 = "Add Spell",
	button2 = "Cancel",
	hasEditBox = true,
	maxLetters = 50,
	editBoxWidth = 200,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	enterClicksFirstButton = true,
	OnAccept = function (self, data)
    	handleCommand(self.editBox:GetText(), data);
	end,
	EditBoxOnTextChanged = function (self)
    	if self:GetText() ~= "" then 
			self:GetParent().button1:Enable();
		else 
			self:GetParent().button1:Disable();
		end
	end
}

StaticPopupDialogs["HADOUKEN_POPUP"] = {
	text = "%s",
	button1 = "Close",
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
}